﻿using Newtonsoft.Json;
using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Chart_GettingStarted
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class DripPage : ContentPage
    {
        private const string Url = "https://thingspeak.com/channels/613888/feed.json";
        private HttpClient _client = new HttpClient();
        private ObservableCollection<Feed> _data;
        SfChart chart;
        LineSeries series;

        public DripPage ()
		{
			InitializeComponent ();

            chart = new SfChart();
            series = new LineSeries();

            chart.PrimaryAxis = new DateTimeAxis();
            chart.SecondaryAxis = new NumericalAxis();

            Content = chart;
        }

        protected override async void OnAppearing()
        {
            var content = await _client.GetStringAsync(Url);
            var data = JsonConvert.DeserializeObject<RootObject>(content);
            _data = new ObservableCollection<Feed>(data.Feeds);

            series.ItemsSource = _data;
            series.XBindingPath = "Created_at";
            series.YBindingPath = "Field1";
            chart.Series.Add(series);

            base.OnAppearing();
        }

        void OnAdd(object sender, System.EventArgs e)
        {
        }

        void OnUpdate(object sender, System.EventArgs e)
        {
        }

        void OnDelete(object sender, System.EventArgs e)
        {
        }
    }
}