﻿using Newtonsoft.Json;
using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net.Http;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Chart_GettingStarted
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class MainPage : ContentPage
    {
        LineSeries series;

        private const string Url = "https://thingspeak.com/channels/613888/feed.json";

        private HttpClient _client = new HttpClient();
        public ObservableCollection<Feed> _data;
        RootObject rootObject = new RootObject();

        public MainPage()
        {
            InitializeComponent();

            SfChart chart = new SfChart();
            series = new LineSeries();
            chart.BindingContext = rootObject;

            chart.PrimaryAxis = new DateTimeAxis();
            chart.SecondaryAxis = new NumericalAxis();
            chart.Series.Add(series);

            Content = chart;
        }

        protected override async void OnAppearing()
        {
            var content = await _client.GetStringAsync(Url);

            var data = JsonConvert.DeserializeObject<RootObject>(content);

            rootObject.Feeds = new ObservableCollection<Feed>(data.Feeds);
            series.ItemsSource = rootObject.Feeds;
            series.XBindingPath = "Created_at";
            series.YBindingPath = "Entry_id";

            base.OnAppearing();
        }

        void OnAdd(object sender, System.EventArgs e)
        {
        }

        void OnUpdate(object sender, System.EventArgs e)
        {
        }

        void OnDelete(object sender, System.EventArgs e)
        {
        }
    }

    public class RootObject : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        ObservableCollection<Feed> feeds = new ObservableCollection<Feed>();
        public ObservableCollection<Feed> Feeds
        {
            get { return feeds; }
            set
            {
                feeds = value;
                NotifyPropertyChanged();
            }
        }

        protected virtual void NotifyPropertyChanged([CallerMemberName] string propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Feed
    {
        public DateTime Created_at { get; set; }
        public int Entry_id { get; set; }
        public string Field1 { get; set; }
        public string Field2 { get; set; }
        public string Field3 { get; set; }
        public string Field4 { get; set; }
        public string Field5 { get; set; }
        public string Field6 { get; set; }
        public string Field7 { get; set; }
        public string Field8 { get; set; }
    }
}